Index: /trunk/LMDZ.GENERIC/libf/phystd/surf_heat_transp_mod.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/surf_heat_transp_mod.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/surf_heat_transp_mod.F90	(revision 1529)
@@ -4,25 +4,123 @@
 MODULE surf_heat_transp_mod
 
-
+IMPLICIT NONE  
+
+  ! Variables copied over from dyn3d dynamics:
+  REAL,SAVE,ALLOCATABLE :: fext(:)
+  REAL,SAVE,ALLOCATABLE :: unsairez(:)
+  REAL,SAVE,ALLOCATABLE :: unsaire(:)
+  REAL,SAVE,ALLOCATABLE :: cu(:)
+  REAL,SAVE,ALLOCATABLE :: cv(:)
+  REAL,SAVE,ALLOCATABLE :: cuvsurcv(:)
+  REAL,SAVE,ALLOCATABLE :: cvusurcu(:)
+  REAL,SAVE,ALLOCATABLE :: aire(:)
+  REAL,SAVE :: apoln
+  REAL,SAVE :: apols
+  REAL,SAVE,ALLOCATABLE :: aireu(:)
+  REAL,SAVE,ALLOCATABLE :: airev(:) 
+
+  LOGICAL,SAVE :: alpha_var
+  LOGICAL,SAVE :: slab_upstream
+  REAL,SAVE,ALLOCATABLE :: zmasqu(:)
+  REAL,SAVE,ALLOCATABLE :: zmasqv(:)
+  REAL,SAVE,ALLOCATABLE :: unsfv(:)
+  REAL,SAVE,ALLOCATABLE :: unsev(:)
+  REAL,SAVE,ALLOCATABLE :: unsfu(:)
+  REAL,SAVE,ALLOCATABLE :: unseu(:)
+
+  ! Routines usable only by routines within this module:
+  PRIVATE :: gr_fi_dyn, gr_dyn_fi
+  ! Routines from dyn3d, valid on global dynamics grid only:
+  PRIVATE :: grad,diverg,gr_u_scal,gr_v_scal
+  
 CONTAINS
-
-      SUBROUTINE divgrad_phy(ngrid,nlevs,temp,delta)
-
-      USE comhdiff_mod, ONLY: zmasqu,zmasqv
-
+  
+  SUBROUTINE ini_surf_heat_transp(ip1jm,ip1jmp1,unsairez_,fext_,unsaire_,&
+                                  cu_,cuvsurcv_,cv_,cvusurcu_, &
+                                  aire_,apoln_,apols_, &
+                                  aireu_,airev_)
+    USE mod_grid_phy_lmdz, only: nbp_lon, nbp_lat
+    IMPLICIT NONE
+    ! Transfer some variables from dyn3d dynamics
+    INTEGER,INTENT(IN) :: ip1jm
+    INTEGER,INTENT(IN) :: ip1jmp1
+    REAL,INTENT(IN) :: unsairez_(ip1jm)
+    REAL,INTENT(IN) :: fext_(ip1jm)
+    REAL,INTENT(IN) :: unsaire_(ip1jmp1)
+    REAL,INTENT(IN) :: cu_(ip1jmp1)
+    REAL,INTENT(IN) :: cuvsurcv_(ip1jm)
+    REAL,INTENT(IN) :: cv_(ip1jm)
+    REAL,INTENT(IN) :: cvusurcu_(ip1jmp1)
+    REAL,INTENT(IN) :: aire_(ip1jmp1)
+    REAL,INTENT(IN) :: apoln_
+    REAL,INTENT(IN) :: apols_
+    REAL,INTENT(IN) :: aireu_(ip1jmp1)
+    REAL,INTENT(IN) :: airev_(ip1jm)
+    
+    ! Sanity check
+    if ((ip1jm.ne.((nbp_lon+1)*(nbp_lat-1))).or. &
+        (ip1jmp1.ne.((nbp_lon+1)*nbp_lat))) then
+      write(*,*) "ini_surf_heat_transp Error: wrong array sizes"
+      stop
+    endif
+    
+    allocate(unsairez(ip1jm))
+    unsairez(:)=unsairez_(:)
+    allocate(fext(ip1jm))
+    fext(:)=fext_(:)
+    allocate(unsaire(ip1jmp1))
+    unsaire(:)=unsaire_(:)
+    allocate(cu(ip1jmp1))
+    cu(:)=cu_(:)
+    allocate(cuvsurcv(ip1jm))
+    cuvsurcv(:)=cuvsurcv_(:)
+    allocate(cv(ip1jm))
+    cv(:)=cv_(:)
+    allocate(cvusurcu(ip1jmp1))
+    cvusurcu(:)=cvusurcu_(:)
+    allocate(aire(ip1jmp1))
+    aire(:)=aire_(:)
+    apoln=apoln_
+    apols=apols_
+    allocate(aireu(ip1jmp1))
+    aireu(:)=aireu_(:)
+    allocate(airev(ip1jm))
+    airev(:)=airev_(:)
+    
+  END SUBROUTINE ini_surf_heat_transp
+  
+  SUBROUTINE ini_surf_heat_transp_mod
+    USE mod_grid_phy_lmdz, only: nbp_lon, nbp_lat
+    IMPLICIT NONE
+    INTEGER :: ip1jm, ip1jmp1
+    
+    ip1jm=(nbp_lon+1)*(nbp_lat-1)
+    ip1jmp1=(nbp_lon+1)*nbp_lat
+  
+    allocate(zmasqu(ip1jmp1))
+    allocate(zmasqv(ip1jm))
+    allocate(unsfv(ip1jm))
+    allocate(unsev(ip1jm))
+    allocate(unsfu(ip1jmp1))
+    allocate(unseu(ip1jmp1))
+
+  END SUBROUTINE ini_surf_heat_transp_mod
+
+  SUBROUTINE divgrad_phy(ngrid,nlevs,temp,delta)
+
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
       IMPLICIT NONE
 
-#include "dimensions.h"
-!#include "dimphys.h"
-#include "paramet.h"
-#include "comgeom.h"
-      
       INTEGER,INTENT(IN) :: ngrid, nlevs
       REAL,INTENT(IN) :: temp(ngrid,nlevs)
       REAL,INTENT(OUT) :: delta(ngrid,nlevs)
-      REAL delta_2d(ip1jmp1,nlevs)
+      REAL delta_2d((nbp_lon+1)*nbp_lat,nlevs)
       INTEGER :: ll
-      REAL ghx(ip1jmp1,nlevs), ghy(ip1jm,nlevs)
-
+      REAL ghx((nbp_lon+1)*nbp_lat,nlevs)
+      REAL ghy((nbp_lon+1)*(nbp_lat-1),nlevs)
+      INTEGER :: iip1,jjp1
+      
+      iip1=nbp_lon+1
+      jjp1=nbp_lat
 
       CALL gr_fi_dyn(nlevs,ngrid,iip1,jjp1,temp,delta_2d)
@@ -42,23 +140,23 @@
 
 
-      SUBROUTINE init_masquv(ngrid,zmasq)
-
-      USE comhdiff_mod, ONLY: zmasqu,zmasqv,unsfu,unsfv,unseu,unsev
-     
+  SUBROUTINE init_masquv(ngrid,zmasq)
+
+      USE mod_grid_phy_lmdz, only: nbp_lon, nbp_lat
       IMPLICIT NONE
-
-#include "dimensions.h"
-!#include "dimphys.h"
-#include "paramet.h"
-#include "comgeom.h"
 
 
       INTEGER,INTENT(IN) :: ngrid
       REAL zmasq(ngrid)
-      REAL zmasq_2d(ip1jmp1)
-      REAL ff(ip1jm)
+      REAL zmasq_2d((nbp_lon+1)*nbp_lat)
+      REAL ff((nbp_lon+1)*(nbp_lat-1))
       REAL eps
       INTEGER i
-
+      INTEGER :: iim,iip1,jjp1,ip1jm,ip1jmp1
+      
+      iim=nbp_lon
+      iip1=nbp_lon+1
+      jjp1=nbp_lat
+      ip1jm=(nbp_lon+1)*(nbp_lat-1)
+      ip1jmp1=(nbp_lon+1)*nbp_lat
 
 ! Masques u,v
@@ -104,27 +202,32 @@
 
 
-      SUBROUTINE slab_ekman2(ngrid,tx_phy,ty_phy,ts_phy,dt_phy)
-  
-          use slab_ice_h 
-          USE comhdiff_mod, ONLY: zmasqu,zmasqv,unsfu,unsfv,unseu,unsev
+  SUBROUTINE slab_ekman2(ngrid,tx_phy,ty_phy,ts_phy,dt_phy)
+  
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+      USE slab_ice_h, ONLY: noceanmx
 
       IMPLICIT NONE
       
-#include "dimensions.h"
-!#include "dimphys.h"
-#include "paramet.h"
-#include "comgeom.h"
-
       INTEGER,INTENT(IN) :: ngrid
       INTEGER ij
-      REAL txv(ip1jm),fluxm(ip1jm),tyv(ip1jm)
-      REAL fluxtm(ip1jm,noceanmx),fluxtz(ip1jmp1,noceanmx)
-      REAL tyu(ip1jmp1),txu(ip1jmp1),fluxz(ip1jmp1),fluxv(ip1jmp1)
-      REAL dt(ip1jmp1,noceanmx),ts(ip1jmp1,noceanmx)
+      REAL txv((nbp_lon+1)*(nbp_lat-1)),fluxm((nbp_lon+1)*(nbp_lat-1))
+      REAL tyv((nbp_lon+1)*(nbp_lat-1))
+      REAL fluxtm((nbp_lon+1)*(nbp_lat-1),noceanmx)
+      REAL fluxtz((nbp_lon+1)*nbp_lat,noceanmx)
+      REAL tyu((nbp_lon+1)*nbp_lat),txu((nbp_lon+1)*nbp_lat)
+      REAL fluxz((nbp_lon+1)*nbp_lat),fluxv((nbp_lon+1)*nbp_lat)
+      REAL dt((nbp_lon+1)*nbp_lat,noceanmx),ts((nbp_lon+1)*nbp_lat,noceanmx)
       REAL tx_phy(ngrid),ty_phy(ngrid)
       REAL dt_phy(ngrid,noceanmx),ts_phy(ngrid,noceanmx)
 
-
-
+      INTEGER iim,iip1,iip2,jjp1,ip1jm,ip1jmi1,ip1jmp1
+
+      iim=nbp_lon
+      iip1=nbp_lon+1
+      iip2=nbp_lon+2
+      jjp1=nbp_lon
+      ip1jm=(nbp_lon+1)*(nbp_lat-1) ! = iip1*jjm
+      ip1jmi1=(nbp_lon+1)*(nbp_lat-1)-(nbp_lon+1) ! = ip1jm - iip1
+      ip1jmp1=(nbp_lon+1)*nbp_lat ! = iip1*jjp1
 
 ! Passage taux,y sur grilles 2d
@@ -226,5 +329,223 @@
   END SUBROUTINE slab_ekman2
 
- 
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  SUBROUTINE gr_fi_dyn(nfield,ngrid,im,jm,pfi,pdyn)
+  ! Transfer a variable on global "physics" grid to global "dynamics" grid
+  IMPLICIT NONE
+
+  INTEGER,INTENT(IN) :: im,jm,ngrid,nfield
+  REAL,INTENT(IN) :: pfi(ngrid,nfield)
+  REAL,INTENT(OUT) :: pdyn(im,jm,nfield)
+  
+  INTEGER :: i,j,ifield,ig
+  
+  DO ifield=1,nfield
+    ! Handle poles
+    DO i=1,im
+      pdyn(i,1,ifield)=pfi(1,ifield)
+      pdyn(i,jm,ifield)=pfi(ngrid,ifield)
+    ENDDO
+    ! Other points
+    DO j=2,jm-1
+      ig=2+(j-2)*(im-1)
+      CALL SCOPY(im-1,pfi(ig,ifield),1,pdyn(1,j,ifield),1)
+      pdyn(im,j,ifield)=pdyn(1,j,ifield)
+    ENDDO
+  ENDDO ! of DO ifield=1,nfield
+  
+  END SUBROUTINE gr_fi_dyn
+  
+
+
+  SUBROUTINE gr_dyn_fi(nfield,im,jm,ngrid,pdyn,pfi)
+  ! Transfer a variable on global "dynamics" grid to global "physics" grid
+  IMPLICIT NONE
+  
+  INTEGER,INTENT(IN) :: im,jm,ngrid,nfield
+  REAL,INTENT(IN) :: pdyn(im,jm,nfield)
+  REAL,INTENT(OUT) :: pfi(ngrid,nfield)
+  
+  INTEGER j,ifield,ig
+
+  ! Sanity check:
+  IF(ngrid.NE.2+(jm-2)*(im-1)) THEN
+    WRITE(*,*) "gr_dyn_fi error, wrong sizes"
+    STOP
+  ENDIF
+  
+  ! Handle poles
+  CALL SCOPY(nfield,pdyn,im*jm,pfi,ngrid)
+  CALL SCOPY(nfield,pdyn(1,jm,1),im*jm,pfi(ngrid,1),ngrid)
+  ! Other points
+  DO ifield=1,nfield
+    DO j=2,jm-1
+      ig=2+(j-2)*(im-1)
+      CALL SCOPY(im-1,pdyn(1,j,ifield),1,pfi(ig,ifield),1)
+    ENDDO
+  ENDDO
+
+  END SUBROUTINE gr_dyn_fi
+
+
+
+  SUBROUTINE  grad(klevel,pg,pgx,pgy)
+  ! compute the covariant components x,y of the gradient of pg
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+  IMPLICIT NONE
+  
+  INTEGER,INTENT(IN) :: klevel
+  REAL,INTENT(IN) :: pg((nbp_lon+1)*nbp_lat,klevel)
+  REAL,INTENT(OUT) :: pgx((nbp_lon+1)*nbp_lat,klevel)
+  REAL,INTENT(OUT) :: pgy((nbp_lon+1)*(nbp_lat-1),klevel)
+
+  INTEGER :: l,ij
+  INTEGER :: iim,iip1,ip1jm,ip1jmp1
+  
+  iim=nbp_lon
+  iip1=nbp_lon+1
+  ip1jm=(nbp_lon+1)*(nbp_lat-1) ! = iip1*jjm
+  ip1jmp1=(nbp_lon+1)*nbp_lat ! = iip1*jjp1
+  
+  DO l=1,klevel
+    DO ij=1,ip1jmp1-1
+      pgx(ij,l)=pg(ij+1,l)-pg(ij,l)
+    ENDDO
+    ! correction for pgx(ip1,j,l) ...
+    ! ... pgx(iip1,j,l)=pgx(1,j,l) ...
+    DO ij=iip1,ip1jmp1,iip1
+      pgx(ij,l)=pgx(ij-iim,l)
+    ENDDO
+    DO ij=1,ip1jm
+      pgy(ij,l)=pg(ij,l)-pg(ij+iip1,l)
+    ENDDO
+  ENDDO
+  
+  END SUBROUTINE grad
+
+
+
+  SUBROUTINE diverg(klevel,x,y,div)
+  ! compute the divergence of a vector field of components
+  ! x,y. y and y being covriant components
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+  IMPLICIT NONE
+  
+  INTEGER,INTENT(IN) :: klevel
+  REAL,INTENT(IN) :: x((nbp_lon+1)*nbp_lat,klevel)
+  REAL,INTENT(IN) :: y((nbp_lon+1)*(nbp_lat-1),klevel)
+  REAL,INTENT(OUT) :: div((nbp_lon+1)*nbp_lat,klevel)
+  
+  INTEGER :: l,ij
+  INTEGER :: iim,iip1,iip2,ip1jm,ip1jmp1,ip1jmi1
+  
+  REAL :: aiy1(nbp_lon+1),aiy2(nbp_lon+1)
+  REAL :: sumypn,sumyps
+  REAL,EXTERNAL :: SSUM
+  
+  iim=nbp_lon
+  iip1=nbp_lon+1
+  iip2=nbp_lon+2
+  ip1jm=(nbp_lon+1)*(nbp_lat-1) ! = iip1*jjm
+  ip1jmp1=(nbp_lon+1)*nbp_lat ! = iip1*jjp1
+  ip1jmi1=(nbp_lon+1)*(nbp_lat-1)-(nbp_lon+1) ! = ip1jm - iip1
+  
+  DO l=1,klevel
+    DO ij=iip2,ip1jm-1
+      div(ij+1,l)= &
+        cvusurcu(ij+1)*x(ij+1,l)-cvusurcu(ij)*x(ij,l)+ &
+        cuvsurcv(ij-iim)*y(ij-iim,l)-cuvsurcv(ij+1)*y(ij+1,l) 
+    ENDDO
+    ! correction for div(1,j,l) ...
+    ! ... div(1,j,l)= div(iip1,j,l) ...
+    DO ij=iip2,ip1jm,iip1
+      div(ij,l)=div(ij+iim,l)
+    ENDDO
+    ! at the poles
+    DO ij=1,iim
+      aiy1(ij)=cuvsurcv(ij)*y(ij,l)
+      aiy2(ij)=cuvsurcv(ij+ip1jmi1)*y(ij+ip1jmi1,l)
+    ENDDO
+    sumypn=SSUM(iim,aiy1,1)/apoln
+    sumyps=SSUM(iim,aiy2,1)/apols
+    DO ij=1,iip1
+      div(ij,l)=-sumypn
+      div(ij+ip1jm,l)=sumyps
+    ENDDO
+  ENDDO ! of DO l=1,klevel
+  
+  !!! CALL filtreg( div, jjp1, klevel, 2, 2, .TRUE., 1 )
+  
+  DO l=1,klevel
+    DO ij=iip2,ip1jm
+      div(ij,l)=div(ij,l)*unsaire(ij) 
+    ENDDO
+  ENDDO
+  
+  END SUBROUTINE diverg
+
+
+
+  SUBROUTINE gr_u_scal(nx,x_u,x_scal)
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+  IMPLICIT NONE
+  
+  INTEGER,INTENT(IN) :: nx
+  REAL,INTENT(IN) :: x_u((nbp_lon+1)*nbp_lat,nx)
+  REAL,INTENT(OUT) :: x_scal((nbp_lon+1)*nbp_lat,nx)
+  
+  INTEGER :: l,ij
+  INTEGER :: iip1,jjp1,ip1jmp1
+  
+  iip1=nbp_lon+1
+  jjp1=nbp_lat
+  ip1jmp1=(nbp_lon+1)*nbp_lat ! = iip1*jjp1
+  
+  DO l=1,nx
+    DO ij=ip1jmp1,2,-1
+      x_scal(ij,l)= &
+                   (aireu(ij)*x_u(ij,l)+aireu(ij-1)*x_u(ij-1,l)) &
+                  /(aireu(ij)+aireu(ij-1))
+    ENDDO
+  ENDDO
+  
+  CALL SCOPY(nx*jjp1,x_scal(iip1,1),iip1,x_scal(1,1),iip1)
+
+  END SUBROUTINE gr_u_scal
+
+
+
+  SUBROUTINE gr_v_scal(nx,x_v,x_scal)
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
+  IMPLICIT NONE
+  
+  INTEGER,INTENT(IN) :: nx
+  REAL,INTENT(IN) :: x_v((nbp_lon+1)*(nbp_lat-1),nx)
+  REAL,INTENT(OUT) :: x_scal((nbp_lon+1)*nbp_lat,nx)
+  
+  INTEGER :: l,ij
+  INTEGER :: iip1,iip2,ip1jm,ip1jmp1
+  
+  iip1=nbp_lon+1
+  iip2=nbp_lon+2
+  ip1jm=(nbp_lon+1)*(nbp_lat-1) ! = iip1*jjm
+  ip1jmp1=(nbp_lon+1)*nbp_lat ! = iip1*jjp1
+  
+  DO l=1,nx
+    DO ij=iip2,ip1jm
+      x_scal(ij,l)= &
+                   (airev(ij-iip1)*x_v(ij-iip1,l)+airev(ij)*x_v(ij,l)) &
+                  /(airev(ij-iip1)+airev(ij))
+    ENDDO
+    DO ij=1,iip1
+      x_scal(ij,l)=0.
+    ENDDO
+    DO ij=ip1jm+1,ip1jmp1
+      x_scal(ij,l)=0.
+    ENDDO
+  ENDDO
+
+  END SUBROUTINE gr_v_scal
+  
 END MODULE surf_heat_transp_mod
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/vdif_kc.F	(revision 1529)
@@ -1,7 +1,4 @@
       SUBROUTINE vdif_kc(ngrid,nlay,dt,g,zlev,zlay,u,v,teta,cd,q2,km,kn)
       IMPLICIT NONE
-c.......................................................................
-!#include "dimensions.h"
-!#include "dimphys.h"
 c.......................................................................
 c
Index: /trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/vlz_fi.F	(revision 1529)
@@ -15,8 +15,4 @@
 c   --------------------------------------------------------------------
       IMPLICIT NONE
-c
-!#include "dimensions.h"
-!#include "dimphys.h"
-
 c
 c
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 1529)
@@ -40,14 +40,13 @@
 !=================================================================
       use surfdat_h, only: phisfi
+      use comgeomphy, only: airephy
       use time_phylmdz_mod, only: ecritphy, day_step, iphysiq, day_ini
       USE mod_phys_lmdz_para, only : is_parallel, is_mpi_root,
      &                               is_master, gather
-      USE mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
+      USE mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo,
+     &                              nbp_lon, nbp_lat, nbp_lev
       implicit none
 
 ! Commons
-      include "dimensions.h"
-      include "paramet.h"
-      include "comgeom.h"
       include "netcdf.inc"
 
@@ -56,11 +55,11 @@
       character (len=*),intent(in) :: nom,titre,unite
       integer,intent(in) :: dim
-      real,intent(in) :: px(ngrid,llm)
+      real,intent(in) :: px(ngrid,nbp_lev)
 
 ! Local variables:
 
-      real*4 dx3(iip1,jjp1,llm) ! to store a 3D data set
-      real*4 dx2(iip1,jjp1)     ! to store a 2D (surface) data set
-      real*4 dx1(llm)           ! to store a 1D (column) data set
+      real*4 dx3(nbp_lon+1,nbp_lat,nbp_lev) ! to store a 3D data set
+      real*4 dx2(nbp_lon+1,nbp_lat)     ! to store a 2D (surface) data set
+      real*4 dx1(nbp_lev)           ! to store a 1D (column) data set
       real*4 dx0
 
@@ -68,10 +67,10 @@
 !$OMP THREADPRIVATE(date)
 
-      REAL phis(ip1jmp1)
+      REAL phis((nbp_lon+1),nbp_lat)
+      REAL area((nbp_lon+1),nbp_lat)
 
       integer irythme
       integer ierr,ierr2
-      integer iq
-      integer i,j,l,zmax , ig0
+      integer i,j,l, ig0
 
       integer,save :: zitau=0
@@ -102,14 +101,16 @@
 #ifdef CPP_PARA
 ! Added to work in parallel mode
-      real dx3_glop(klon_glo,llm)
-      real dx3_glo(iim,jjp1,llm) ! to store a global 3D data set
+      real dx3_glop(klon_glo,nbp_lev)
+      real dx3_glo(nbp_lon,nbp_lat,nbp_lev) ! to store a global 3D data set
       real dx2_glop(klon_glo)
-      real dx2_glo(iim,jjp1)     ! to store a global 2D (surface) data set
+      real dx2_glo(nbp_lon,nbp_lat)     ! to store a global 2D (surface) data set
       real px2(ngrid)
-!      real dx1_glo(llm)          ! to store a 1D (column) data set
+!      real dx1_glo(nbp_lev)          ! to store a 1D (column) data set
 !      real dx0_glo
       real phisfi_glo(klon_glo) ! surface geopotential on global physics grid
+      real areafi_glo(klon_glo) ! mesh area on global physics grid
 #else
       real phisfi_glo(ngrid) ! surface geopotential on global physics grid
+      real areafi_glo(ngrid) ! mesh area on global physics grid
 #endif
 
@@ -117,5 +118,5 @@
 !Sortie des variables au rythme voulu
 
-      irythme = ecritphy ! sortie au rythme de ecritphy
+      irythme = int(ecritphy) ! sortie au rythme de ecritphy
 !     irythme = iconser  ! sortie au rythme des variables de controle
 !     irythme = iphysiq  ! sortie a tous les pas physique
@@ -188,6 +189,9 @@
           ! Gather phisfi() geopotential on physics grid
           call Gather(phisfi,phisfi_glo)
+          ! Gather airephy() mesh area on physics grid
+          call Gather(airephy,areafi_glo)
 #else
          phisfi_glo(:)=phisfi(:)
+         areafi_glo(:)=airephy(:)
 #endif
 
@@ -216,7 +220,25 @@
          ierr = NF_ENDDEF(nid)
 
+         ! Build phis() and area()
+         do i=1,nbp_lon+1 ! poles
+           phis(i,1)=phisfi_glo(1)
+           phis(i,nbp_lat)=phisfi_glo(klon_glo)
+           ! for area, divide at the poles by nbp_lon
+           area(i,1)=areafi_glo(1)/nbp_lon
+           area(i,nbp_lat)=areafi_glo(klon_glo)/nbp_lon
+         enddo
+         do j=2,nbp_lat-1
+           ig0= 1+(j-2)*nbp_lon
+           do i=1,nbp_lon
+              phis(i,j)=phisfi_glo(ig0+i)
+              area(i,j)=areafi_glo(ig0+i)
+           enddo
+           ! handle redundant point in longitude
+           phis(nbp_lon+1,j)=phis(1,j)
+           area(nbp_lon+1,j)=area(1,j)
+         enddo
+         
          ! write "header" of file (longitudes, latitudes, geopotential, ...)
-         call gr_fi_dyn(1,size(phisfi_glo),iip1,jjp1,phisfi_glo,phis)
-         call iniwrite(nid,day_ini,phis)
+         call iniwrite(nid,day_ini,phis,area)
 
          endif ! of if (is_master)
@@ -234,7 +256,8 @@
 
       if (ngrid.eq.1) then
-        ! in testphys1d, for the 1d version of the GCM, iphysiq 
-        ! should be most likely 1 (because no dyn!)
+        ! in testphys1d, for the 1d version of the GCM, iphysiq and irythme
+        ! are undefined; so set them to 1
         iphysiq=1 
+        irythme=1
         ! NB: 
       endif
@@ -296,6 +319,6 @@
             call Grid1Dto2D_glo(dx3_glop,dx3_glo)
             ! copy dx3_glo() to dx3(:) and add redundant longitude
-            dx3(1:iim,:,:)=dx3_glo(1:iim,:,:)
-            dx3(iip1,:,:)=dx3(1,:,:)
+            dx3(1:nbp_lon,:,:)=dx3_glo(1:nbp_lon,:,:)
+            dx3(nbp_lon+1,:,:)=dx3(1,:,:)
           endif
 !$OMP END MASTER
@@ -304,15 +327,15 @@
 !         Passage variable physique -->  variable dynamique
 !         recast (copy) variable from physics grid to dynamics grid
-           DO l=1,llm
-             DO i=1,iip1
+           DO l=1,nbp_lev
+             DO i=1,nbp_lon+1
                 dx3(i,1,l)=px(1,l)
-                dx3(i,jjp1,l)=px(ngrid,l)
+                dx3(i,nbp_lat,l)=px(ngrid,l)
              ENDDO
-             DO j=2,jjm
-                ig0= 1+(j-2)*iim
-                DO i=1,iim
+             DO j=2,nbp_lat-1
+                ig0= 1+(j-2)*nbp_lon
+                DO i=1,nbp_lon
                    dx3(i,j,l)=px(ig0+i,l)
                 ENDDO
-                dx3(iip1,j,l)=dx3(1,j,l)
+                dx3(nbp_lon+1,j,l)=dx3(1,j,l)
              ENDDO
            ENDDO
@@ -344,7 +367,7 @@
            corner(4)=ntime
 
-           edges(1)=iip1
-           edges(2)=jjp1
-           edges(3)=llm
+           edges(1)=nbp_lon+1
+           edges(2)=nbp_lat
+           edges(3)=nbp_lev
            edges(4)=1
 !#ifdef NC_DOUBLE
@@ -380,6 +403,6 @@
             call Grid1Dto2D_glo(dx2_glop,dx2_glo)
             ! copy dx2_glo() to dx2(:) and add redundant longitude
-            dx2(1:iim,:)=dx2_glo(1:iim,:)
-            dx2(iip1,:)=dx2(1,:)
+            dx2(1:nbp_lon,:)=dx2_glo(1:nbp_lon,:)
+            dx2(nbp_lon+1,:)=dx2(1,:)
           endif
 !$OMP END MASTER
@@ -390,14 +413,14 @@
 !         recast (copy) variable from physics grid to dynamics grid
 
-             DO i=1,iip1
+             DO i=1,nbp_lon+1
                 dx2(i,1)=px(1,1)
-                dx2(i,jjp1)=px(ngrid,1)
+                dx2(i,nbp_lat)=px(ngrid,1)
              ENDDO
-             DO j=2,jjm
-                ig0= 1+(j-2)*iim
-                DO i=1,iim
+             DO j=2,nbp_lat-1
+                ig0= 1+(j-2)*nbp_lon
+                DO i=1,nbp_lon
                    dx2(i,j)=px(ig0+i,1)
                 ENDDO
-                dx2(iip1,j)=dx2(1,j)
+                dx2(nbp_lon+1,j)=dx2(1,j)
              ENDDO
 #endif
@@ -426,6 +449,6 @@
            corner(2)=1
            corner(3)=ntime
-           edges(1)=iip1
-           edges(2)=jjp1
+           edges(1)=nbp_lon+1
+           edges(2)=nbp_lat
            edges(3)=1
 
@@ -457,5 +480,5 @@
 !         Passage variable physique -->  physique dynamique
 !         recast (copy) variable from physics grid to dynamics grid
-          do l=1,llm
+          do l=1,nbp_lev
             dx1(l)=px(1,l)
           enddo
@@ -479,5 +502,5 @@
            corner(2)=ntime
            
-           edges(1)=llm
+           edges(1)=nbp_lev
            edges(2)=1
 !#ifdef NC_DOUBLE
@@ -543,3 +566,4 @@
 
 #endif
+! of #ifndef MESOSCALE
       end
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90	(revision 1529)
@@ -12,14 +12,14 @@
 ! Modifs: Aug.2010 Ehouarn: enforce outputs to be real*4
 
-use comsoil_h, only: nsoilmx
+use comsoil_h, only: nsoilmx, inertiedat
+use comgeomphy, only: airephy
 use time_phylmdz_mod, only: ecritphy, day_step, iphysiq
 use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
-use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
+use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo, &
+                              nbp_lon, nbp_lat
 
 implicit none
 
-#include"dimensions.h"
-#include"paramet.h"
-#include"netcdf.inc"
+include"netcdf.inc"
 
 ! Arguments:
@@ -31,10 +31,8 @@
 integer,intent(in) :: dimpx ! dimension of the variable (3,2 or 0)
 real,dimension(ngrid,nsoilmx),intent(in) :: px ! variable
-! Note: nsoilmx is a parameter set in 'comsoil_h'
 
 ! Local variables:
-real*4,dimension(iip1,jjp1,nsoilmx) :: data3 ! to store 3D data
-! Note iip1,jjp1 known from paramet.h; nsoilmx known from comsoil_h
-real*4,dimension(iip1,jjp1) :: data2 ! to store 2D data
+real*4,dimension(nbp_lon+1,nbp_lat,nsoilmx) :: data3 ! to store 3D data
+real*4,dimension(nbp_lon+1,nbp_lat) :: data2 ! to store 2D data
 real*4 :: data0 ! to store 0D data
 integer :: i,j,l ! for loops
@@ -42,4 +40,11 @@
 
 real*4,save :: date ! time counter (in elapsed days)
+
+real :: inertia((nbp_lon+1),nbp_lat,nsoilmx)
+real :: area((nbp_lon+1),nbp_lat)
+
+real :: inertiafi_glo(klon_glo,nsoilmx)
+real :: areafi_glo(klon_glo)
+
 integer,save :: isample ! sample rate at which data is to be written to output
 integer,save :: ntime=0 ! counter to internally store time steps
@@ -60,7 +65,7 @@
 ! Added to work in parallel mode
 real dx3_glop(klon_glo,nsoilmx)
-real dx3_glo(iim,jjp1,nsoilmx) ! to store a global 3D data set
+real dx3_glo(nbp_lon,nbp_lat,nsoilmx) ! to store a global 3D data set
 real dx2_glop(klon_glo)
-real dx2_glo(iim,jjp1)     ! to store a global 2D (surface) data set
+real dx2_glo(nbp_lon,nbp_lat)     ! to store a global 2D (surface) data set
 real px2(ngrid)
 #endif
@@ -81,5 +86,5 @@
   
   ! Set output sample rate
-  isample=ecritphy ! same as for diagfi outputs
+  isample=int(ecritphy) ! same as for diagfi outputs
   ! Note ecritphy is known from control.h
   
@@ -91,8 +96,38 @@
     stop
    endif
+
+#ifdef CPP_PARA
+   ! Gather inertiedat() soil thermal inertia on physics grid
+   call Gather(inertiedat,inertiafi_glo)
+   ! Gather airephy() mesh area on physics grid
+   call Gather(airephy,areafi_glo)
+#else
+         inertiafi_glo(:,:)=inertiedat(:,:)
+         areafi_glo(:)=airephy(:)
+#endif
+
+   ! build inertia() and area()
+   do i=1,nbp_lon+1 ! poles
+     inertia(i,1,1:nsoilmx)=inertiafi_glo(1,1:nsoilmx)
+     inertia(i,nbp_lat,1:nsoilmx)=inertiafi_glo(klon_glo,1:nsoilmx)
+     ! for area, divide at the poles by nbp_lon
+     area(i,1)=areafi_glo(1)/nbp_lon
+     area(i,nbp_lat)=areafi_glo(klon_glo)/nbp_lon
+   enddo
+   do j=2,nbp_lat-1
+     ig0= 1+(j-2)*nbp_lon
+     do i=1,nbp_lon
+        inertia(i,j,1:nsoilmx)=inertiafi_glo(ig0+i,1:nsoilmx)
+        area(i,j)=areafi_glo(ig0+i)
+     enddo
+     ! handle redundant point in longitude
+     inertia(nbp_lon+1,j,1:nsoilmx)=inertia(1,j,1:nsoilmx)
+     area(nbp_lon+1,j)=area(1,j)
+   enddo
+   
+   ! write "header" of file (longitudes, latitudes, geopotential, ...)
+   call iniwritesoil(nid,ngrid,inertia,area)
+
   endif ! of if (is_master)
-
-  ! Define dimensions and axis attributes
-  call iniwritesoil(nid,ngrid)
   
   ! set zitau to -1 to be compatible with zitau incrementation step below
@@ -148,6 +183,6 @@
     call Grid1Dto2D_glo(dx3_glop,dx3_glo)
     ! copy dx3_glo() to dx3(:) and add redundant longitude
-    data3(1:iim,:,:)=dx3_glo(1:iim,:,:)
-    data3(iip1,:,:)=data3(1,:,:)
+    data3(1:nbp_lon,:,:)=dx3_glo(1:nbp_lon,:,:)
+    data3(nbp_lon+1,:,:)=data3(1,:,:)
   endif
 !$OMP END MASTER
@@ -156,15 +191,15 @@
   do l=1,nsoilmx
     ! handle the poles
-    do i=1,iip1
+    do i=1,nbp_lon+1
       data3(i,1,l)=px(1,l)
-      data3(i,jjp1,l)=px(ngrid,l)
+      data3(i,nbp_lat,l)=px(ngrid,l)
     enddo
     ! rest of the grid
-    do j=2,jjm
-      ig0=1+(j-2)*iim
-      do i=1,iim
+    do j=2,nbp_lat-1
+      ig0=1+(j-2)*nbp_lon
+      do i=1,nbp_lon
         data3(i,j,l)=px(ig0+i,l)
       enddo
-      data3(iip1,j,l)=data3(1,j,l) ! extra (modulo) longitude
+      data3(nbp_lon+1,j,l)=data3(1,j,l) ! extra (modulo) longitude
     enddo
   enddo
@@ -195,6 +230,6 @@
   corners(4)=ntime
   
-  edges(1)=iip1
-  edges(2)=jjp1
+  edges(1)=nbp_lon+1
+  edges(2)=nbp_lat
   edges(3)=nsoilmx
   edges(4)=1
@@ -223,6 +258,6 @@
     call Grid1Dto2D_glo(dx2_glop,dx2_glo)
     ! copy dx3_glo() to dx3(:) and add redundant longitude
-    data2(1:iim,:)=dx2_glo(1:iim,:)
-    data2(iip1,:)=data2(1,:)
+    data2(1:nbp_lon,:)=dx2_glo(1:nbp_lon,:)
+    data2(nbp_lon+1,:)=data2(1,:)
   endif
 !$OMP END MASTER
@@ -230,15 +265,15 @@
 #else
   ! handle the poles
-  do i=1,iip1
+  do i=1,nbp_lon+1
     data2(i,1)=px(1,1)
-    data2(i,jjp1)=px(ngrid,1)
+    data2(i,nbp_lat)=px(ngrid,1)
   enddo
   ! rest of the grid
-  do j=2,jjm
-    ig0=1+(j-2)*iim
-    do i=1,iim
+  do j=2,nbp_lat-1
+    ig0=1+(j-2)*nbp_lon
+    do i=1,nbp_lon
       data2(i,j)=px(ig0+i,1)
     enddo
-    data2(iip1,j)=data2(1,j) ! extra (modulo) longitude
+    data2(nbp_lon+1,j)=data2(1,j) ! extra (modulo) longitude
   enddo
 #endif
@@ -266,6 +301,6 @@
   corners(3)=ntime
   
-  edges(1)=iip1
-  edges(2)=jjp1
+  edges(1)=nbp_lon+1
+  edges(2)=nbp_lat
   edges(3)=1
   
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagspecIR.F	(revision 1529)
@@ -43,9 +43,8 @@
 ! Addition by RW (2010) to allow OLR to be saved in .nc format
       use radinc_h, only : L_NSPECTI
-!      USE surfdat_h, only : phisfi
-#ifdef CPP_PARA
+      use comgeomphy, only: airephy
       use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
-      use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-#endif
+      use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo,
+     &                              nbp_lon, nbp_lat
       use time_phylmdz_mod, only: ecritphy, iphysiq, day_step, day_ini
       use callkeys_mod, only: iradia
@@ -53,11 +52,5 @@
       implicit none
 
-! Commons
-#include "dimensions.h"
-!#include "dimphys.h"
-#include "paramet.h"
-!#include "control.h"
-#include "comgeom.h"
-#include "netcdf.inc"
+      include "netcdf.inc"
 
 ! Arguments on input:
@@ -73,8 +66,4 @@
 !      real dx0
 
-      real date
-
-!      REAL phis(ip1jmp1)
-
       integer irythme
       integer ierr
@@ -82,11 +71,7 @@
       integer i,j,l,zmax , ig0
 
-      integer zitau
-      character firstnom*20
-      SAVE firstnom
-      SAVE zitau
-      SAVE date
-      data firstnom /'1234567890'/
-      data zitau /0/
+      integer,save :: zitau=0
+      character(len=20),save :: firstnom='1234567890'
+      real,save :: date
 !$OMP THREADPRIVATE(firstnom,zitau,date)
 
@@ -100,14 +85,15 @@
       integer, dimension(4) :: edges,corner
 
+      real area((nbp_lon+1),nbp_lat)
 ! added by RDW for OLR output
-       real dx3(iip1,jjp1,L_NSPECTI) ! to store the data set
+       real dx3(nbp_lon+1,nbp_lat,L_NSPECTI) ! to store the data set
 
 #ifdef CPP_PARA
 ! Added to work in parallel mode
       real dx3_glop(klon_glo,L_NSPECTI)
-      real dx3_glo(iim,jjp1,L_NSPECTI) ! to store a global 3D data set
-#else
-      logical,parameter :: is_master=.true.
-      logical,parameter :: is_mpi_root=.true.
+      real dx3_glo(nbp_lon,nbp_lat,L_NSPECTI) ! to store a global 3D data set
+      real areafi_glo(klon_glo) ! mesh area on global physics grid
+#else
+      real areafi_glo(ngrid) ! mesh area on global physics grid
 #endif
 
@@ -139,4 +125,10 @@
          endif
 
+#ifdef CPP_PARA
+          ! Gather airephy() mesh area on physics grid
+          call Gather(airephy,areafi_glo)
+#else
+         areafi_glo(:)=airephy(:)
+#endif
          ! Create the NetCDF file
          if (is_master) then
@@ -159,7 +151,21 @@
          ierr = NF_ENDDEF(nid)
 
-!         call gr_fi_dyn(1,size(phisfi_glo),iip1,jjp1,phisfi_glo,phis)
+         ! Build area()
+         do i=1,nbp_lon+1 ! poles
+           ! divide at the poles by nbp_lon
+           area(i,1)=areafi_glo(1)/nbp_lon
+           area(i,nbp_lat)=areafi_glo(klon_glo)/nbp_lon
+         enddo
+         do j=2,nbp_lat-1
+           ig0= 1+(j-2)*nbp_lon
+           do i=1,nbp_lon
+              area(i,j)=areafi_glo(ig0+i)
+           enddo
+           ! handle redundant point in longitude
+           area(nbp_lon+1,j)=area(1,j)
+         enddo
+
          ! write "header" of file (longitudes, latitudes, area, ...)
-         call iniwrite_specIR(nid,day_ini)
+         call iniwrite_specIR(nid,day_ini,area)
          endif ! of if (is_master)
 
@@ -215,5 +221,5 @@
              endif
 
-             write(6,*)'WRITEDIAGSPEC: date= ', date
+             write(6,*)'WRITEDIAGSPECIR: date= ', date
            endif ! of if (is_master)
         end if ! of if (nom.eq.firstnom)
@@ -233,6 +239,6 @@
             call Grid1Dto2D_glo(dx3_glop,dx3_glo)
             ! copy dx3_glo() to dx3(:) and add redundant longitude
-            dx3(1:iim,:,:)=dx3_glo(1:iim,:,:)
-            dx3(iip1,:,:)=dx3(1,:,:)
+            dx3(1:nbp_lon,:,:)=dx3_glo(1:nbp_lon,:,:)
+            dx3(nbp_lon+1,:,:)=dx3(1,:,:)
           endif
 !$OMP END MASTER
@@ -240,14 +246,14 @@
 #else
            DO l=1,L_NSPECTI
-             DO i=1,iip1
+             DO i=1,nbp_lon+1
                 dx3(i,1,l)=px(1,l)
-                dx3(i,jjp1,l)=px(ngrid,l)
+                dx3(i,nbp_lat,l)=px(ngrid,l)
              ENDDO
-             DO j=2,jjm
-                ig0= 1+(j-2)*iim
-                DO i=1,iim
+             DO j=2,nbp_lat-1
+                ig0= 1+(j-2)*nbp_lon
+                DO i=1,nbp_lon
                    dx3(i,j,l)=px(ig0+i,l)
                 ENDDO
-                dx3(iip1,j,l)=dx3(1,j,l)
+                dx3(nbp_lon+1,j,l)=dx3(1,j,l)
              ENDDO
            ENDDO
@@ -279,6 +285,6 @@
            corner(4)=ntime
 
-           edges(1)=iip1
-           edges(2)=jjp1
+           edges(1)=nbp_lon+1
+           edges(2)=nbp_lat
            edges(3)=L_NSPECTI
            edges(4)=1
